<center><a href="mmbaij.c">Actual source code: mmbaij.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:24:57+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCMAT_DLL</font></strong>

<a name="line3">  3: </a><font color="#B22222">/*</font>
<a name="line4">  4: </a><font color="#B22222">   Support for the parallel BAIJ matrix vector multiply</font>
<a name="line5">  5: </a><font color="#B22222">*/</font>
<a name="line6"> 6: </a> #include <A href="../../../../../src/mat/impls/baij/mpi/mpibaij.h.html">src/mat/impls/baij/mpi/mpibaij.h</A>

<a name="line8">  8: </a><strong><font color="#4169E1">EXTERN <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatSetValuesBlocked_SeqBAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,const <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>[],<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,const <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>[],const <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>[],<A href="../../../../../docs/manualpages/Sys/InsertMode.html#InsertMode">InsertMode</A>)</font></strong>;

<a name="line12"> 12: </a><strong><font color="#4169E1"><a name="MatSetUpMultiply_MPIBAIJ"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatSetUpMultiply_MPIBAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> mat)</font></strong>
<a name="line13"> 13: </a>{
<a name="line14"> 14: </a>  Mat_MPIBAIJ    *baij = (Mat_MPIBAIJ*)mat-&gt;data;
<a name="line15"> 15: </a>  Mat_SeqBAIJ    *B = (Mat_SeqBAIJ*)(baij-&gt;B-&gt;data);
<a name="line17"> 17: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,j,*aj = B-&gt;j,ec = 0,*garray;
<a name="line18"> 18: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       bs = mat-&gt;rmap.bs,*stmp;
<a name="line19"> 19: </a>  <A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>             from,to;
<a name="line20"> 20: </a>  <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            gvec;
<a name="line21"> 21: </a><font color="#A020F0">#if defined (PETSC_USE_CTABLE)</font>
<a name="line22"> 22: </a>  PetscTable     gid1_lid1;
<a name="line23"> 23: </a>  PetscTablePosition tpos;
<a name="line24"> 24: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       gid,lid;
<a name="line25"> 25: </a><font color="#A020F0">#else</font>
<a name="line26"> 26: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       Nbs = baij-&gt;Nbs,*indices;
<a name="line27"> 27: </a><font color="#A020F0">#endif  </font>


<a name="line31"> 31: </a><font color="#A020F0">#if defined (PETSC_USE_CTABLE)</font>
<a name="line32"> 32: </a>  <font color="#B22222">/* use a table - Mark Adams */</font>
<a name="line33"> 33: </a>  PetscTableCreate(B-&gt;mbs,&amp;gid1_lid1);
<a name="line34"> 34: </a>  <font color="#4169E1">for</font> (i=0; i&lt;B-&gt;mbs; i++) {
<a name="line35"> 35: </a>    <font color="#4169E1">for</font> (j=0; j&lt;B-&gt;ilen[i]; j++) {
<a name="line36"> 36: </a>      <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> data,gid1 = aj[B-&gt;i[i]+j] + 1;
<a name="line37"> 37: </a>      PetscTableFind(gid1_lid1,gid1,&amp;data);
<a name="line38"> 38: </a>      <font color="#4169E1">if</font> (!data) {
<a name="line39"> 39: </a>        <font color="#B22222">/* one based table */</font>
<a name="line40"> 40: </a>        PetscTableAdd(gid1_lid1,gid1,++ec);
<a name="line41"> 41: </a>      }
<a name="line42"> 42: </a>    }
<a name="line43"> 43: </a>  }
<a name="line44"> 44: </a>  <font color="#B22222">/* form array of columns we need */</font>
<a name="line45"> 45: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((ec+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;garray);
<a name="line46"> 46: </a>  PetscTableGetHeadPosition(gid1_lid1,&amp;tpos);
<a name="line47"> 47: </a>  <font color="#4169E1">while</font> (tpos) {
<a name="line48"> 48: </a>    PetscTableGetNext(gid1_lid1,&amp;tpos,&amp;gid,&amp;lid);
<a name="line49"> 49: </a>    gid--; lid--;
<a name="line50"> 50: </a>    garray[lid] = gid;
<a name="line51"> 51: </a>  }
<a name="line52"> 52: </a>  <A href="../../../../../docs/manualpages/Sys/PetscSortInt.html#PetscSortInt">PetscSortInt</A>(ec,garray);
<a name="line53"> 53: </a>  PetscTableRemoveAll(gid1_lid1);
<a name="line54"> 54: </a>  <font color="#4169E1">for</font> (i=0; i&lt;ec; i++) {
<a name="line55"> 55: </a>    PetscTableAdd(gid1_lid1,garray[i]+1,i+1);
<a name="line56"> 56: </a>  }
<a name="line57"> 57: </a>  <font color="#B22222">/* compact out the extra columns in B */</font>
<a name="line58"> 58: </a>  <font color="#4169E1">for</font> (i=0; i&lt;B-&gt;mbs; i++) {
<a name="line59"> 59: </a>    <font color="#4169E1">for</font> (j=0; j&lt;B-&gt;ilen[i]; j++) {
<a name="line60"> 60: </a>      <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> gid1 = aj[B-&gt;i[i] + j] + 1;
<a name="line61"> 61: </a>      PetscTableFind(gid1_lid1,gid1,&amp;lid);
<a name="line62"> 62: </a>      lid --;
<a name="line63"> 63: </a>      aj[B-&gt;i[i]+j] = lid;
<a name="line64"> 64: </a>    }
<a name="line65"> 65: </a>  }
<a name="line66"> 66: </a>  B-&gt;nbs     = ec;
<a name="line67"> 67: </a>  baij-&gt;B-&gt;cmap.n = baij-&gt;B-&gt;cmap.N = ec*mat-&gt;rmap.bs;
<a name="line68"> 68: </a>  <A href="../../../../../docs/manualpages/Vec/PetscMapInitialize.html#PetscMapInitialize">PetscMapInitialize</A>(baij-&gt;B-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;(baij-&gt;B-&gt;cmap));
<a name="line69"> 69: </a>  PetscTableDelete(gid1_lid1);
<a name="line70"> 70: </a>  <font color="#B22222">/* Mark Adams */</font>
<a name="line71"> 71: </a><font color="#A020F0">#else</font>
<a name="line72"> 72: </a>  <font color="#B22222">/* Make an array as long as the number of columns */</font>
<a name="line73"> 73: </a>  <font color="#B22222">/* mark those columns that are in baij-&gt;B */</font>
<a name="line74"> 74: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((Nbs+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;indices);
<a name="line75"> 75: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMemzero.html#PetscMemzero">PetscMemzero</A>(indices,Nbs*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>));
<a name="line76"> 76: </a>  <font color="#4169E1">for</font> (i=0; i&lt;B-&gt;mbs; i++) {
<a name="line77"> 77: </a>    <font color="#4169E1">for</font> (j=0; j&lt;B-&gt;ilen[i]; j++) {
<a name="line78"> 78: </a>      <font color="#4169E1">if</font> (!indices[aj[B-&gt;i[i] + j]]) ec++;
<a name="line79"> 79: </a>      indices[aj[B-&gt;i[i] + j]] = 1;
<a name="line80"> 80: </a>    }
<a name="line81"> 81: </a>  }

<a name="line83"> 83: </a>  <font color="#B22222">/* form array of columns we need */</font>
<a name="line84"> 84: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((ec+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;garray);
<a name="line85"> 85: </a>  ec = 0;
<a name="line86"> 86: </a>  <font color="#4169E1">for</font> (i=0; i&lt;Nbs; i++) {
<a name="line87"> 87: </a>    <font color="#4169E1">if</font> (indices[i]) {
<a name="line88"> 88: </a>      garray[ec++] = i;
<a name="line89"> 89: </a>    }
<a name="line90"> 90: </a>  }

<a name="line92"> 92: </a>  <font color="#B22222">/* make indices now point into garray */</font>
<a name="line93"> 93: </a>  <font color="#4169E1">for</font> (i=0; i&lt;ec; i++) {
<a name="line94"> 94: </a>    indices[garray[i]] = i;
<a name="line95"> 95: </a>  }

<a name="line97"> 97: </a>  <font color="#B22222">/* compact out the extra columns in B */</font>
<a name="line98"> 98: </a>  <font color="#4169E1">for</font> (i=0; i&lt;B-&gt;mbs; i++) {
<a name="line99"> 99: </a>    <font color="#4169E1">for</font> (j=0; j&lt;B-&gt;ilen[i]; j++) {
<a name="line100">100: </a>      aj[B-&gt;i[i] + j] = indices[aj[B-&gt;i[i] + j]];
<a name="line101">101: </a>    }
<a name="line102">102: </a>  }
<a name="line103">103: </a>  B-&gt;nbs       = ec;
<a name="line104">104: </a>  baij-&gt;B-&gt;cmap.n =baij-&gt;B-&gt;cmap.N  = ec*mat-&gt;rmap.bs;
<a name="line105">105: </a>  <A href="../../../../../docs/manualpages/Vec/PetscMapInitialize.html#PetscMapInitialize">PetscMapInitialize</A>(baij-&gt;B-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;(baij-&gt;B-&gt;cmap));
<a name="line106">106: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(indices);
<a name="line107">107: </a><font color="#A020F0">#endif  </font>

<a name="line109">109: </a>  <font color="#B22222">/* create local vector that is used to scatter into */</font>
<a name="line110">110: </a>  <A href="../../../../../docs/manualpages/Vec/VecCreateSeq.html#VecCreateSeq">VecCreateSeq</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,ec*bs,&amp;baij-&gt;lvec);

<a name="line112">112: </a>  <font color="#B22222">/* create two temporary index sets for building scatter-gather */</font>
<a name="line113">113: </a>  <font color="#4169E1">for</font> (i=0; i&lt;ec; i++) {
<a name="line114">114: </a>    garray[i] = bs*garray[i];
<a name="line115">115: </a>  }
<a name="line116">116: </a>  <A href="../../../../../docs/manualpages/IS/ISCreateBlock.html#ISCreateBlock">ISCreateBlock</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,bs,ec,garray,&amp;from);
<a name="line117">117: </a>  <font color="#4169E1">for</font> (i=0; i&lt;ec; i++) {
<a name="line118">118: </a>    garray[i] = garray[i]/bs;
<a name="line119">119: </a>  }

<a name="line121">121: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((ec+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;stmp);
<a name="line122">122: </a>  <font color="#4169E1">for</font> (i=0; i&lt;ec; i++) { stmp[i] = bs*i; }
<a name="line123">123: </a>  <A href="../../../../../docs/manualpages/IS/ISCreateBlock.html#ISCreateBlock">ISCreateBlock</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,bs,ec,stmp,&amp;to);
<a name="line124">124: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(stmp);

<a name="line126">126: </a>  <font color="#B22222">/* create temporary global vector to generate scatter context */</font>
<a name="line127">127: </a>  <font color="#B22222">/* this is inefficient, but otherwise we must do either </font>
<a name="line128">128: </a><font color="#B22222">     1) save garray until the first actual scatter when the vector is known or</font>
<a name="line129">129: </a><font color="#B22222">     2) have another way of generating a scatter context without a vector.*/</font>
<a name="line130">130: </a>  <A href="../../../../../docs/manualpages/Vec/VecCreateMPI.html#VecCreateMPI">VecCreateMPI</A>(mat-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,mat-&gt;cmap.n,mat-&gt;cmap.N,&amp;gvec);

<a name="line132">132: </a>  <A href="../../../../../docs/manualpages/Vec/VecScatterCreate.html#VecScatterCreate">VecScatterCreate</A>(gvec,from,baij-&gt;lvec,to,&amp;baij-&gt;Mvctx);

<a name="line134">134: </a>  PetscLogObjectParent(mat,baij-&gt;Mvctx);
<a name="line135">135: </a>  PetscLogObjectParent(mat,baij-&gt;lvec);
<a name="line136">136: </a>  PetscLogObjectParent(mat,from);
<a name="line137">137: </a>  PetscLogObjectParent(mat,to);
<a name="line138">138: </a>  baij-&gt;garray = garray;
<a name="line139">139: </a>  PetscLogObjectMemory(mat,(ec+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>));
<a name="line140">140: </a>  <A href="../../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(from);
<a name="line141">141: </a>  <A href="../../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(to);
<a name="line142">142: </a>  <A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(gvec);
<a name="line143">143: </a>  <font color="#4169E1">return</font>(0);
<a name="line144">144: </a>}

<a name="line146">146: </a><font color="#B22222">/*</font>
<a name="line147">147: </a><font color="#B22222">     Takes the local part of an already assembled MPIBAIJ matrix</font>
<a name="line148">148: </a><font color="#B22222">   and disassembles it. This is to allow new nonzeros into the matrix</font>
<a name="line149">149: </a><font color="#B22222">   that require more communication in the matrix vector multiply. </font>
<a name="line150">150: </a><font color="#B22222">   Thus certain data-structures must be rebuilt.</font>

<a name="line152">152: </a><font color="#B22222">   Kind of slow! But that's what application programmers get when </font>
<a name="line153">153: </a><font color="#B22222">   they are sloppy.</font>
<a name="line154">154: </a><font color="#B22222">*/</font>
<a name="line157">157: </a><strong><font color="#4169E1"><a name="DisAssemble_MPIBAIJ"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> DisAssemble_MPIBAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A)</font></strong>
<a name="line158">158: </a>{
<a name="line159">159: </a>  Mat_MPIBAIJ    *baij = (Mat_MPIBAIJ*)A-&gt;data;
<a name="line160">160: </a>  <A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>            B = baij-&gt;B,Bnew;
<a name="line161">161: </a>  Mat_SeqBAIJ    *Bbaij = (Mat_SeqBAIJ*)B-&gt;data;
<a name="line163">163: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,j,mbs=Bbaij-&gt;mbs,n = A-&gt;cmap.n,col,*garray=baij-&gt;garray;
<a name="line164">164: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       bs2 = baij-&gt;bs2,*nz,ec,m = A-&gt;rmap.n;
<a name="line165">165: </a>  MatScalar      *a = Bbaij-&gt;a;
<a name="line166">166: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *atmp;
<a name="line167">167: </a><font color="#A020F0">#if defined(PETSC_USE_MAT_SINGLE)</font>
<a name="line168">168: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       k;
<a name="line169">169: </a><font color="#A020F0">#endif</font>

<a name="line172">172: </a>  <font color="#B22222">/* free stuff related to matrix-vec multiply */</font>
<a name="line173">173: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetSize.html#VecGetSize">VecGetSize</A>(baij-&gt;lvec,&amp;ec); <font color="#B22222">/* needed for PetscLogObjectMemory below */</font>
<a name="line174">174: </a>  <A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(baij-&gt;lvec); baij-&gt;lvec = 0;
<a name="line175">175: </a>  <A href="../../../../../docs/manualpages/Vec/VecScatterDestroy.html#VecScatterDestroy">VecScatterDestroy</A>(baij-&gt;Mvctx); baij-&gt;Mvctx = 0;
<a name="line176">176: </a>  <font color="#4169E1">if</font> (baij-&gt;colmap) {
<a name="line177">177: </a><font color="#A020F0">#if defined (PETSC_USE_CTABLE)</font>
<a name="line178">178: </a>    PetscTableDelete(baij-&gt;colmap); baij-&gt;colmap = 0;
<a name="line179">179: </a><font color="#A020F0">#else</font>
<a name="line180">180: </a>    <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(baij-&gt;colmap);
<a name="line181">181: </a>    baij-&gt;colmap = 0;
<a name="line182">182: </a>    PetscLogObjectMemory(A,-Bbaij-&gt;nbs*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>));
<a name="line183">183: </a><font color="#A020F0">#endif</font>
<a name="line184">184: </a>  }

<a name="line186">186: </a>  <font color="#B22222">/* make sure that B is assembled so we can access its values */</font>
<a name="line187">187: </a>  <A href="../../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>(B,MAT_FINAL_ASSEMBLY);
<a name="line188">188: </a>  <A href="../../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>(B,MAT_FINAL_ASSEMBLY);

<a name="line190">190: </a>  <font color="#B22222">/* invent new B and copy stuff over */</font>
<a name="line191">191: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(mbs*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;nz);
<a name="line192">192: </a>  <font color="#4169E1">for</font> (i=0; i&lt;mbs; i++) {
<a name="line193">193: </a>    nz[i] = Bbaij-&gt;i[i+1]-Bbaij-&gt;i[i];
<a name="line194">194: </a>  }
<a name="line195">195: </a>  <A href="../../../../../docs/manualpages/Mat/MatCreate.html#MatCreate">MatCreate</A>(B-&gt;<A href="../../../../../docs/manualpages/Sys/comm.html#comm">comm</A>,&amp;Bnew);
<a name="line196">196: </a>  <A href="../../../../../docs/manualpages/Mat/MatSetSizes.html#MatSetSizes">MatSetSizes</A>(Bnew,m,n,m,n);
<a name="line197">197: </a>  <A href="../../../../../docs/manualpages/Mat/MatSetType.html#MatSetType">MatSetType</A>(Bnew,B-&gt;type_name);
<a name="line198">198: </a>  <A href="../../../../../docs/manualpages/Mat/MatSeqBAIJSetPreallocation.html#MatSeqBAIJSetPreallocation">MatSeqBAIJSetPreallocation</A>(Bnew,B-&gt;rmap.bs,0,nz);
<a name="line199">199: </a>  <A href="../../../../../docs/manualpages/Mat/MatSetOption.html#MatSetOption">MatSetOption</A>(Bnew,MAT_COLUMN_ORIENTED);

<a name="line201">201: </a><font color="#A020F0">#if defined(PETSC_USE_MAT_SINGLE)</font>
<a name="line202">202: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(bs2*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>),&amp;atmp);
<a name="line203">203: </a><font color="#A020F0">#endif</font>
<a name="line204">204: </a>    <font color="#4169E1">for</font> (i=0; i&lt;mbs; i++) {
<a name="line205">205: </a>      <font color="#4169E1">for</font> (j=Bbaij-&gt;i[i]; j&lt;Bbaij-&gt;i[i+1]; j++) {
<a name="line206">206: </a>        col  = garray[Bbaij-&gt;j[j]];
<a name="line207">207: </a><font color="#A020F0">#if defined(PETSC_USE_MAT_SINGLE)</font>
<a name="line208">208: </a>        <font color="#4169E1">for</font> (k=0; k&lt;bs2; k++) atmp[k] = a[j*bs2+k];
<a name="line209">209: </a><font color="#A020F0">#else</font>
<a name="line210">210: </a>        atmp = a + j*bs2;
<a name="line211">211: </a><font color="#A020F0">#endif</font>
<a name="line212">212: </a>        MatSetValuesBlocked_SeqBAIJ(Bnew,1,&amp;i,1,&amp;col,atmp,B-&gt;insertmode);
<a name="line213">213: </a>      }
<a name="line214">214: </a>    }
<a name="line215">215: </a>  <A href="../../../../../docs/manualpages/Mat/MatSetOption.html#MatSetOption">MatSetOption</A>(Bnew,MAT_ROW_ORIENTED);

<a name="line217">217: </a><font color="#A020F0">#if defined(PETSC_USE_MAT_SINGLE)</font>
<a name="line218">218: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(atmp);
<a name="line219">219: </a><font color="#A020F0">#endif</font>

<a name="line221">221: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(nz);
<a name="line222">222: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(baij-&gt;garray);
<a name="line223">223: </a>  baij-&gt;garray = 0;
<a name="line224">224: </a>  PetscLogObjectMemory(A,-ec*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>));
<a name="line225">225: </a>  <A href="../../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(B);
<a name="line226">226: </a>  PetscLogObjectParent(A,Bnew);
<a name="line227">227: </a>  baij-&gt;B = Bnew;
<a name="line228">228: </a>  A-&gt;was_assembled = <A href="../../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line229">229: </a>  <font color="#4169E1">return</font>(0);
<a name="line230">230: </a>}

<a name="line232">232: </a><font color="#B22222">/*      ugly stuff added for Glenn someday we should fix this up */</font>

<a name="line234">234: </a>static <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *uglyrmapd = 0,*uglyrmapo = 0;  <font color="#B22222">/* mapping from the local ordering to the "diagonal" and "off-diagonal"</font>
<a name="line235">235: </a><font color="#B22222">                                      parts of the local matrix */</font>
<a name="line236">236: </a>static <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> uglydd = 0,uglyoo = 0;   <font color="#B22222">/* work vectors used to scale the two parts of the local matrix */</font>


<a name="line241">241: </a><strong><font color="#4169E1"><a name="MatMPIBAIJDiagonalScaleLocalSetUp"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MatMPIBAIJDiagonalScaleLocalSetUp(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> inA,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> scale)</font></strong>
<a name="line242">242: </a>{
<a name="line243">243: </a>  Mat_MPIBAIJ    *ina = (Mat_MPIBAIJ*) inA-&gt;data; <font color="#B22222">/*access private part of matrix */</font>
<a name="line244">244: </a>  Mat_SeqBAIJ    *B = (Mat_SeqBAIJ*)ina-&gt;B-&gt;data;
<a name="line246">246: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       bs = inA-&gt;rmap.bs,i,n,nt,j,cstart,cend,no,*garray = ina-&gt;garray,*lindices;
<a name="line247">247: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       *r_rmapd,*r_rmapo;
<a name="line248">248: </a>
<a name="line250">250: </a>  <A href="../../../../../docs/manualpages/Mat/MatGetOwnershipRange.html#MatGetOwnershipRange">MatGetOwnershipRange</A>(inA,&amp;cstart,&amp;cend);
<a name="line251">251: </a>  <A href="../../../../../docs/manualpages/Mat/MatGetSize.html#MatGetSize">MatGetSize</A>(ina-&gt;A,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,&amp;n);
<a name="line252">252: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((inA-&gt;bmapping-&gt;n+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;r_rmapd);
<a name="line253">253: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMemzero.html#PetscMemzero">PetscMemzero</A>(r_rmapd,inA-&gt;bmapping-&gt;n*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>));
<a name="line254">254: </a>  nt   = 0;
<a name="line255">255: </a>  <font color="#4169E1">for</font> (i=0; i&lt;inA-&gt;bmapping-&gt;n; i++) {
<a name="line256">256: </a>    <font color="#4169E1">if</font> (inA-&gt;bmapping-&gt;indices[i]*bs &gt;= cstart &amp;&amp; inA-&gt;bmapping-&gt;indices[i]*bs &lt; cend) {
<a name="line257">257: </a>      nt++;
<a name="line258">258: </a>      r_rmapd[i] = inA-&gt;bmapping-&gt;indices[i] + 1;
<a name="line259">259: </a>    }
<a name="line260">260: </a>  }
<a name="line261">261: </a>  <font color="#4169E1">if</font> (nt*bs != n) <A href="../../../../../docs/manualpages/Sys/SETERRQ2.html#SETERRQ2">SETERRQ2</A>(PETSC_ERR_PLIB,<font color="#666666">"Hmm nt*bs %D n %D"</font>,nt*bs,n);
<a name="line262">262: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((n+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;uglyrmapd);
<a name="line263">263: </a>  <font color="#4169E1">for</font> (i=0; i&lt;inA-&gt;bmapping-&gt;n; i++) {
<a name="line264">264: </a>    <font color="#4169E1">if</font> (r_rmapd[i]){
<a name="line265">265: </a>      <font color="#4169E1">for</font> (j=0; j&lt;bs; j++) {
<a name="line266">266: </a>        uglyrmapd[(r_rmapd[i]-1)*bs+j-cstart] = i*bs + j;
<a name="line267">267: </a>      }
<a name="line268">268: </a>    }
<a name="line269">269: </a>  }
<a name="line270">270: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(r_rmapd);
<a name="line271">271: </a>  <A href="../../../../../docs/manualpages/Vec/VecCreateSeq.html#VecCreateSeq">VecCreateSeq</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,n,&amp;uglydd);

<a name="line273">273: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((ina-&gt;Nbs+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;lindices);
<a name="line274">274: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMemzero.html#PetscMemzero">PetscMemzero</A>(lindices,ina-&gt;Nbs*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>));
<a name="line275">275: </a>  <font color="#4169E1">for</font> (i=0; i&lt;B-&gt;nbs; i++) {
<a name="line276">276: </a>    lindices[garray[i]] = i+1;
<a name="line277">277: </a>  }
<a name="line278">278: </a>  no   = inA-&gt;bmapping-&gt;n - nt;
<a name="line279">279: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((inA-&gt;bmapping-&gt;n+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;r_rmapo);
<a name="line280">280: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMemzero.html#PetscMemzero">PetscMemzero</A>(r_rmapo,inA-&gt;bmapping-&gt;n*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>));
<a name="line281">281: </a>  nt   = 0;
<a name="line282">282: </a>  <font color="#4169E1">for</font> (i=0; i&lt;inA-&gt;bmapping-&gt;n; i++) {
<a name="line283">283: </a>    <font color="#4169E1">if</font> (lindices[inA-&gt;bmapping-&gt;indices[i]]) {
<a name="line284">284: </a>      nt++;
<a name="line285">285: </a>      r_rmapo[i] = lindices[inA-&gt;bmapping-&gt;indices[i]];
<a name="line286">286: </a>    }
<a name="line287">287: </a>  }
<a name="line288">288: </a>  <font color="#4169E1">if</font> (nt &gt; no) <A href="../../../../../docs/manualpages/Sys/SETERRQ2.html#SETERRQ2">SETERRQ2</A>(PETSC_ERR_PLIB,<font color="#666666">"Hmm nt %D no %D"</font>,nt,n);
<a name="line289">289: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(lindices);
<a name="line290">290: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((nt*bs+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;uglyrmapo);
<a name="line291">291: </a>  <font color="#4169E1">for</font> (i=0; i&lt;inA-&gt;bmapping-&gt;n; i++) {
<a name="line292">292: </a>    <font color="#4169E1">if</font> (r_rmapo[i]){
<a name="line293">293: </a>      <font color="#4169E1">for</font> (j=0; j&lt;bs; j++) {
<a name="line294">294: </a>        uglyrmapo[(r_rmapo[i]-1)*bs+j] = i*bs + j;
<a name="line295">295: </a>      }
<a name="line296">296: </a>    }
<a name="line297">297: </a>  }
<a name="line298">298: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(r_rmapo);
<a name="line299">299: </a>  <A href="../../../../../docs/manualpages/Vec/VecCreateSeq.html#VecCreateSeq">VecCreateSeq</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,nt*bs,&amp;uglyoo);

<a name="line301">301: </a>  <font color="#4169E1">return</font>(0);
<a name="line302">302: </a>}

<a name="line306">306: </a><strong><font color="#4169E1"><a name="MatMPIBAIJDiagonalScaleLocal"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  MatMPIBAIJDiagonalScaleLocal(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> scale)</font></strong>
<a name="line307">307: </a>{
<a name="line308">308: </a>  <font color="#B22222">/* This routine should really be abandoned as it duplicates <A href="../../../../../docs/manualpages/Mat/MatDiagonalScaleLocal.html#MatDiagonalScaleLocal">MatDiagonalScaleLocal</A> */</font>
<a name="line309">309: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> ierr,(*f)(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>);

<a name="line312">312: </a>  <A href="../../../../../docs/manualpages/Sys/PetscObjectQueryFunction.html#PetscObjectQueryFunction">PetscObjectQueryFunction</A>((<A href="../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)A,<font color="#666666">"MatDiagonalScaleLocal_C"</font>,(void (**)(void))&amp;f);
<a name="line313">313: </a>  <font color="#4169E1">if</font> (f) {
<a name="line314">314: </a>    (*f)(A,scale);
<a name="line315">315: </a>  }
<a name="line316">316: </a>  <font color="#4169E1">return</font>(0);
<a name="line317">317: </a>}

<a name="line322">322: </a><strong><font color="#4169E1"><a name="MatDiagonalScaleLocal_MPIBAIJ"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  MatDiagonalScaleLocal_MPIBAIJ(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> A,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> scale)</font></strong>
<a name="line323">323: </a>{
<a name="line324">324: </a>  Mat_MPIBAIJ    *a = (Mat_MPIBAIJ*) A-&gt;data; <font color="#B22222">/*access private part of matrix */</font>
<a name="line326">326: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       n,i;
<a name="line327">327: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *d,*o,*s;
<a name="line328">328: </a>
<a name="line330">330: </a>  <font color="#4169E1">if</font> (!uglyrmapd) {
<a name="line331">331: </a>    MatMPIBAIJDiagonalScaleLocalSetUp(A,scale);
<a name="line332">332: </a>  }

<a name="line334">334: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(scale,&amp;s);
<a name="line335">335: </a>
<a name="line336">336: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetLocalSize.html#VecGetLocalSize">VecGetLocalSize</A>(uglydd,&amp;n);
<a name="line337">337: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(uglydd,&amp;d);
<a name="line338">338: </a>  <font color="#4169E1">for</font> (i=0; i&lt;n; i++) {
<a name="line339">339: </a>    d[i] = s[uglyrmapd[i]]; <font color="#B22222">/* copy "diagonal" (true local) portion of scale into dd vector */</font>
<a name="line340">340: </a>  }
<a name="line341">341: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(uglydd,&amp;d);
<a name="line342">342: </a>  <font color="#B22222">/* column scale "diagonal" portion of local matrix */</font>
<a name="line343">343: </a>  <A href="../../../../../docs/manualpages/Mat/MatDiagonalScale.html#MatDiagonalScale">MatDiagonalScale</A>(a-&gt;A,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,uglydd);

<a name="line345">345: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetLocalSize.html#VecGetLocalSize">VecGetLocalSize</A>(uglyoo,&amp;n);
<a name="line346">346: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(uglyoo,&amp;o);
<a name="line347">347: </a>  <font color="#4169E1">for</font> (i=0; i&lt;n; i++) {
<a name="line348">348: </a>    o[i] = s[uglyrmapo[i]]; <font color="#B22222">/* copy "off-diagonal" portion of scale into oo vector */</font>
<a name="line349">349: </a>  }
<a name="line350">350: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(scale,&amp;s);
<a name="line351">351: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(uglyoo,&amp;o);
<a name="line352">352: </a>  <font color="#B22222">/* column scale "off-diagonal" portion of local matrix */</font>
<a name="line353">353: </a>  <A href="../../../../../docs/manualpages/Mat/MatDiagonalScale.html#MatDiagonalScale">MatDiagonalScale</A>(a-&gt;B,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,uglyoo);

<a name="line355">355: </a>  <font color="#4169E1">return</font>(0);
<a name="line356">356: </a>}


</pre>
</body>

</html>
